# Writing Hello World in Ballerina

## Creating a new Ballerina project

1. Go to **File -> New -> Project**. Select **Ballerina** project type and click **Next** button.

![alt text](images/Figure-1-1.png)

2. In the next step, we are prompted to select a SDK for the project. If you haven't already added a SDK, please follow [Setting up Ballerina SDK](../setting-up-ballerina-sdk) documentation to add a new SDK.

   Select the SDK and click **Next** button.

![alt text](images/Figure-1-2.png)

3. Update the project name and the location and click **Next** button.

![alt text](images/Figure-1-3.png)

Now you have successfully created a new **Ballerina** project.

![alt text](images/Figure-1-4.png)

## Creating a new Ballerina file

1. **Right click** on the project and select **New -> Ballerina File**.

![alt text](images/Figure-2-1.png)

2. Enter the file name and click **OK** button. We use **Ballerina Main** as the **Kind**. This will create a new file with a **main** function.

![alt text](images/Figure-2-2.png)

Now you should have a new Ballerina file with a **main** function.

![alt text](images/Figure-2-3.png)

## Running Ballerina Files

### Running Ballerina Mains

Near the main function, in the gutter area, **Run** icon can be found.

![alt text](images/Figure-3-1.png)

Clicking on this **Run** icon, available commands can be viewed.

![alt text](images/Figure-3-2.png)

Select **Run** command. This will run the main function and show the output in the **Run** window.

![alt text](images/Figure-3-3.png)

Note: You can right click on the file and run the main method as well.

### Running Ballerina Services

This is similar to running main functions. Near the service definition, in the gutter area, **Run** icon can be found. Clicking on this **Run** icon, available commands can be viewed. Select **Run** command. This will start the service and show the output in the **Run** window. Please note that running a Ballerina file with few services will start all services in that file.

![alt text](images/Figure-4-1.png)

Note: You can right click on the file and run the services as well.
